# 1 "boot.S"
# 1 "<built-in>"
# 1 "<command line>"
# 1 "boot.S"
# Proolix-l stage2 main program
# usage 'make install' for install stage2 to diskette /dev/fd0
 
        .code16
	.include "macros.S"
	
STRLEN	=	80
Drive	=	0	#   A: (FDD 0, /dev/fd0) 
	
	.text
.global _start
_start:

    print	str1
    call	print_registers
    newline
    # command cycle
l_revert:
    print prompt
    
    xorw %bx,%bx # string index
    
    # get string
l_next_char:

    movb $0,%ah
    int $0x16	# getch to %al
    
    cmpb $0x0d,%al
    je	l_str_ok
    
    movb %al,keystroke(%bx)
    
    putch %al # echo
    
    incw %bx
    
    cmpw $STRLEN,%bx
    je l_str_overflow
    jmp l_next_char
    
l_str_overflow:
    print s_too_len_str
    jmp l_revert    
    
l_str_ok:
    movb $0,keystroke(%bx)
    
    # analiz of keystroke
    
    cmpb $0,keystroke
    je l_revert # empty keystroke
    
    ### command c1
    xorw %bx,%bx
c1_0:  
    movb c1_s(%bx),%al
    cmpb %al,keystroke(%bx)
    jne	c1_1
    mov keystroke(%bx),%dl
    orb %al,%dl
    jz c1_2
    incw %bx
    jmp c1_0
c1_2:	# this command
    print s_help
    jmp l_revert
c1_1:	#    no this command
    ###
    
    ### command c2
    xorw %bx,%bx
c2_0:  
    movb c2_s(%bx),%al
    cmpb %al,keystroke(%bx)
    jne	c2_1
    movb keystroke(%bx),%dl
    orb %al,%dl
    jz c2_2
    incw %bx
    jmp c2_0
c2_2:	# this command
        movw    $0x40,%ax
        movw    %ax,%ds
        movw    $0x72,%bx
        movw    $0x1234,(%bx)

        .byte   0xea            # JMP   F000:FFF0
        .word   0xfff0,0xf000
	
c2_1:	#    no this command
    ###
    
    ### command c3
    xorw %bx,%bx
c3_0:  
    movb c3_s(%bx),%al
    cmpb %al,keystroke(%bx)
    jne	c3_1
    movb keystroke(%bx),%dl
    orb %al,%dl
    jz c3_2
    incw %bx
    jmp c3_0
c3_2:	# this command
        movw    $0x40,%ax
        movw    %ax,%ds
        movw    $0x72,%bx
        movw    $0x4321,(%bx)

        .byte   0xea            # JMP   F000:FFF0
        .word   0xfff0,0xf000
	
c3_1:	#    no this command
    ###
    
    ### command c4
    xorw %bx,%bx
c4_0:  
    movb c4_s(%bx),%al
    cmpb %al,keystroke(%bx)
    jne	c4_1
    movb keystroke(%bx),%dl
    orb %al,%dl
    jz c4_2
    incw %bx
    jmp c4_0
c4_2:	# this command
        xorw    %ax,%ax
        movw    %ax,%ES

        # Read MBR
        movw    $0x0080,%dx  # dl-drive, dh-head
l_read_mbr_:
	movw	$0x0001,%cx  # cl - sector, ch - track

	movw	$0x0201,%ax  # al - sectors count, ah - function (read)

        movw     $0x7c00,%bx
        int     $0x13
        nop
        jc      c4_reboot

        # jmp    0:7c00
        .byte      0xea
        .word      0x7c00
        .word      0

c4_reboot:# jmp  ffff:0	# ffff:0 = ffff0
        .byte      0xea
        .word      0
        .word      0xffff
	
c4_1:	#    no this command
    ###
    
    ### command c5
    xorw %bx,%bx
c5_0:  
    movb c5_s(%bx),%al
    cmpb %al,keystroke(%bx)
    jne	c5_1
    movb keystroke(%bx),%dl
    orb %al,%dl
    jz c5_2
    incw %bx
    jmp c5_0
c5_2:	# this command
        xorw    %ax,%ax
        movw    %ax,%ES

        # Read MBR
        movw    $0x0081,%dx  # dl-drive, dh-head
	jmp	l_read_mbr_
	
c5_1:	#    no this command
    ###
    
    ### command c6
    xorw %bx,%bx
c6_0:  
    movb c6_s(%bx),%al
    cmpb %al,keystroke(%bx)
    jne	c6_1
    movb keystroke(%bx),%dl
    orb %al,%dl
    jz c6_2
    incw %bx
    jmp c6_0
c6_2:	# this command
    #
	newline
        # 
        movb    FatCnt,%al
        cbw
        movw    FatSize,%cx
	mulw    %cx      # %ax*%cx -> %dx:%ax
        addw    ResSecs,%ax
        # %ax - Root Beginning Sector
        movw    %ax,StartClu
        PUSHW   %ax

        movw    RootSiz,%ax
        movw    $32,%cx
        mulw    %cx

        movw    SectSiz,%cx
        divw    %cx       # %dx:%ax / %cx -> %ax; mod -> %dx
        orw     %dx,%dx   #   ,    
        jz      l_ll      #  (   root')
        incw    %ax
l_ll:
        # %ax - Root Size in Sectors
        addw    %ax,StartClu
        movw    %ax,%cx
        movw    %ax,RootSize
	    print	s_lines
	    putch	$':'
	    movw		%cx,%ax
	    call	ohw
        POPW    %ax      # %ax - Root Bg Sec
	    movw	$1,%cx
	    putch	$','
	    call	ohw
loop1:  #         
        #  
        pushw   %cx

        pushw   %ax
        movw    $Buff,%bx
        movb    $Drive,%dl
        pushw   %ax
        call    SecRead
        jnc     l_ok
	putch	$'E' # error
l_ok:	
        popw    %ax
        movw    $16,%cx   # root entryes in 1 sector
loop2:          pushw   %cx
		pushw	%bx

		movb	(%bx),%al
		orb	%al,%al
		jz	l_empty_dirent
		cmpb	$0xE5,%al
		je	l_empty_dirent
                movw    $11,%cx
loop3:          	putch	(%bx)
			incw	%bx		
			loop	loop3
		
l_empty_dirent:		
		newline
		popw	%bx
                popw    %cx
                addw    $32,%bx
                loop    loop2

        popw    %ax
        incw    %ax

        popw    %cx
	putch	$'s'
        loop    loop1
        # end of load root dir
	jmp	l_revert
     
c6_1:	#    no this command
    ###
    
#invalid command
    
    print s_inv
    
    jmp l_revert

SecRead: # proc    # ver 0.0.1   3-Nov-94 (for FDD boot)

                # Read absolute sectors
                # Input: %ax - abs sec number
                #        %dl - drive (for int 0x13 Fn=2)
                #        ES:%bx - buffer
                #        DS - data segment reg

                # Use global variables:
                # word ptr HeadCnt
                # word ptr TrkSecs

                # Output: cf=1 if error
                # NO ALL REGS SAVED !!!

#       pushw    %ax
        pushw    %bx
        pushw    %cx
        pushw    %dx
        pushw    %si
        pushw    %di
 
        movw    %bx,%si   # save %bx & %dx
        movw    %dx,%di

        PUSHW    %ax

        movw    HeadCnt,%ax
        movw    TrkSecs,%cx
        mulw     %cx      # %dx:%ax := HeadCnt * TrkSecs
        movw    %ax,%bx  # %bx = HeadCnt * TrkSecs

        POPW     %ax
        xorw     %dx,%dx   # %dx:%ax - Abs Sec No
        div     %bx # %ax=Track=AbsSec/(HeadCnt*TrkSecs); %dx - mod (Sec on Cyl)

        movw    %ax,%bx   # %bx - track no

        movw    %dx,%ax
        xorw    %dx,%dx   # %dx:%ax - module (Sec on Cyl)
        div     %cx # Head=[%dx:%ax]/TrkSecs;%ax - Head; mod (%dx) - Sec on Head-1
        incw    %dx # %dx - Sec on Head

        movw    $1,%cx
l_loop:
        pushw    %cx

        movb     %dl,%cl    # sector
        movb     %bl,%ch    # track ; Warning: track < 255 !!!
        movw     %si,%bx    # Restore %bx - offset for buff
        movw     %di,%dx    # Restore %dl - drive no
        movb     %al,%dh    # head
        movw     $0x201,%ax # Fn=02, Read 1 sector
        int      $0x13
        jnc     l_break

        popw     %cx
        loop    l_loop
        jmp     l_ret
l_break:
        popw     %cx
l_ret:
        popw     %di
        popw     %si
        popw     %dx
        popw     %cx
        popw     %bx
#       popw     %ax

        ret
# SecRead endp

keystroke: .fill STRLEN,1,0

str1:	.byte		13,10
	.ascii		"Proolix-l stage2. Use 'help' for help"
	.byte 		13,10,0
prompt:	.byte	13,10
	.asciz		"> "
s_too_len_str: .ascii "Too length string"
	.byte 13,10,0
s_inv:	.byte 13,10
	.ascii "Invalid command"	
	.byte 13,10,0
c1_s: .asciz "help"
c2_s: .asciz "reboot"
c3_s: .asciz "cold"
c4_s: .asciz "hdd0"
c5_s: .asciz "hdd1"
c6_s: .asciz "ls"
s_help: .byte 13,10,13,10
.ascii "Proolix-l stage2 commands:"
.byte 13,10
.ascii "help - this help ;)"
.byte 13,10
.ascii "ls - list of files (kernels)"
.byte 13,10
.ascii "reboot - hot reboot"
.byte 13,10
.ascii "cold - cold reboot"
.byte 13,10
.ascii "hdd0 - load OS from HDD 0"
.byte 13,10
.ascii "hdd1 - load OS from HDD 1 (if present)"
.byte 13,10
.byte 13,10
.ascii "With best regards, Prool. http://prool.kharkov.org/proolix/"
	.byte 13,10,0
	
s_debug:	.asciz "DEBUG"	
s_lines:	.asciz "Root size in sectors, root bg sec"	

SectSiz:         .word      512
ClustSiz:        .byte      2
ResSecs:         .word      1
FatCnt:          .byte      2
RootSiz:         .word      112
TotSecs:         .word      720
FatSize:         .word      2
TrkSecs:         .word      9
HeadCnt:         .word      2
HidnSec:         .word      0,0
BigNo:           .word      0,0       # Big total no of sectors
StartClu:        .word      0       
RootSize:        .word      0
Buff:
